<?php
/*
+------------------------------------------------------------------------+
| ConPresso-Module "Brute Force Protection"                              |
+------------------------------------------------------------------------+
| Copyright (c) Markus Rsel http://www.conpresso4.de                    |
+------------------------------------------------------------------------+
| LICENSE INFO                                                           |
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| MODULE LICENSE                                                         |
| This souce file is also subject to the module license available        |
| through the world-wide-web at                                          |
|    http://www.conpresso4.de/_rubric/index.php?rubric=Lizenzbedingungen |
| It is NOT freeware and must not be redistributed!                      |
+------------------------------------------------------------------------+
| Authors: Markus Rsel <mods@50n.de>                                    |
+------------------------------------------------------------------------+

Version 4.0 / December 2013

*/


define('CPO', true);
require_once('../_include/checkaccess.inc.php'); 

// Moduleinstellungen speichern (neue Version mit automatischem Einlesen neuer Variablen)************
if (isset($_POST['go'])) {
	$new_settings = $_POST;
    foreach ($activeModules['brute_force'] as $k=>$v) {
        if (!isset($_POST['cpobrute_forceNew'][$k])) continue;
        if (is_bool($activeModules['brute_force'][$k])) {
            $activeModules['brute_force'][$k] = (bool) $_POST['cpobrute_forceNew'][$k];
        } else {
			$activeModules['brute_force'][$k] = $_POST['cpobrute_forceNew'][$k];
		}
		if (array_key_exists($k, $new_settings['cpobrute_forceNew'])) unset($new_settings['cpobrute_forceNew'][$k]);
    }
    foreach ($new_settings['cpobrute_forceNew'] as $k=>$v) {
		$activeModules['brute_force'][$k] = $new_settings['cpobrute_forceNew'][$k];
	}
    $c_datum = date ("Y-m-d H:i:s", time());
    $query = sprintf(
             "UPDATE ".CPO_MODULES." SET options ="
            ." '%s' WHERE name = '%s'", 
            addslashes(serialize($activeModules['brute_force'])),
			'brute_force'
    );
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB;
    $db->query($query); 

    $message[] = __('Module settings were updated!');
}

require(CPO_BASEDIR.'_include/header.php');

printPageHeader(
    __('Brute Force Protection'),
    __('In this view you can work on the brute force protection module settings.'),
	'http://manual.conpresso4.de/brute_force/settings.htm',
	true,
	'modules'
);
include(CPO_BASEDIR.'_include/message.php');
include(CPO_BASEDIR.'mod_brute_force/producer.inc.php');

if(array_key_exists('brute_force', $activeModules))  {

	
	echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="modulesettings">';
	echo '<input type="hidden" name="go" value="1">';

    // table header {{{
    echo '<table class="colored" style="width: 100%;">';
    echo '<thead><tr>';

    echo '<th colspan="2"><span>'.__('Brute force protection settings').'</span></th>';

    echo '</tr></thead><tbody>';
    // }}}

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Activate brute force protection:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpobrute_forceNew[active]" size="1">';
        $selyes = ($activeModules['brute_force']['active']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['brute_force']['active']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select><br />';
        echo __('In order to make the brute force protection work you need to install the premodded files or edit the following files:').'<br />';
        echo '<b>_admin/index.php:</b> ';
        echo __('find the <b>second</b> appearance of').' ';
        echo '<b>CPOsession_start();</b>'.'<br />';
        echo __('after add').' ';
        echo '<b>include(CPO_BASEDIR.\'mod_brute_force/brute_force.inc.php\');</b>'.'<br />';
        if (version_compare($CPO['version'], '4.1.0') >= 0) {
            echo '<b>_include/member.inc.php:</b> ';
        } else {
            echo '<b>_rubric/member.php:</b> ';
        }
        echo __('find the <b>first</b> appearance of').' ';
        echo '<b>CPOsession_start();</b>'.'<br />';
        echo __('after add').' ';
        echo '<b>include(CPO_BASEDIR.\'mod_brute_force/brute_force.inc.php\');</b>'.'<br />';
        if (version_compare($CPO['version'], '4.1.0') >= 0) {
            echo __('(check any module directory for legacy member.php files (>3kB))');
        } else {
            echo __('(check any rubric and module directory for further member.php files (>3kB))');
        }
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('IP blocking time in hours:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text" name="cpobrute_forceNew[periodinhours]" value="'.$activeModules['brute_force']['periodinhours'].'" size="5" maxlength="5">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Allowed attempts:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text" name="cpobrute_forceNew[allowedattempts]" value="'.$activeModules['brute_force']['allowedattempts'].'" size="5" maxlength="5">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Alert by mail:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<select name="cpobrute_forceNew[sendMail]" size="1">';
        $selyes = ($activeModules['brute_force']['sendMail']=="yes") ? ' selected="selected"' :'';
        $selno = ($activeModules['brute_force']['sendMail']=="no") ? ' selected="selected"' :'';
        echo '<option value="yes"'.$selyes.'>'.__('yes').'</option>';
        echo '<option value="no"'.$selno.'>'.__('no').'</option>';
        echo '</select>';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Sender email adress:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpobrute_forceNew[sender]" value="'.$activeModules['brute_force']['sender'].'" maxlength="255">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Recipient email adress:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpobrute_forceNew[recipient]" value="'.$activeModules['brute_force']['recipient'].'" maxlength="255">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo __('Alert mail subject:');
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="text inputwidth" name="cpobrute_forceNew[subject]" value="'.$activeModules['brute_force']['subject'].'" maxlength="255">';
        echo '</td>';
    echo '</tr>';

    echo '<tr>';
        echo '<td class="leftrow">';
        echo '&nbsp;';
        echo '</td>';
        echo '<td class="rightrow">';
        echo '<input type="submit" class="button" value="'.__('Save module settings').'">';
        echo '</td>';
    echo '</tr>';
    echo '</tbody></table>';
	
	echo '</form>';

}

$blocks = array();
$blockdb = new DB;
$query = "SELECT datum, bemerkung FROM ".$dbPrefix."_log WHERE
  aktion = 'login fail' AND datum > '".date("Y-m-d H:i:s", time() - ($activeModules['brute_force']['periodinhours'] * 60 * 60) )."' ORDER BY id ASC";
$blockdb->query($query);
if ($blockdb->num_rows()>0)  {
    while ($blockdb->next_record()) {
        $logBemerkung = explode(" / ", $blockdb->v('bemerkung'));
        $blocks[$logBemerkung[0]][] = $blockdb->v('datum');
    }
}
if(count($blocks)>0)  {
    foreach($blocks AS $blockkey=>$blockdates) {
        if (count($blockdates) <= $activeModules['brute_force']['allowedattempts']) unset ($blocks[$blockkey]); // not blocked!
    }
}
if(count($blocks)>0)  {
    echo '<p>'.__('These ip adresses are actually blocked.').'</p>';
    echo '<table class="ruler" style="width: 100%;">';
    echo "<thead><tr><th><span>".__('IP adress')."</span></th><th><span>".__('blocked until')."</span></th></tr></thead><tbody>";
    foreach($blocks AS $blockkey=>$blockdates) {
        echo "<tr>";
        echo "<td>";
        echo $blockkey;
        echo "</td>";
        echo "<td>";
        echo date("Y-m-d H:i:s", strtotime($blockdates[0]) + ($activeModules['brute_force']['periodinhours'] * 60 * 60));
        echo "</td>";
        echo "</tr>";
    }
    echo "</tbody></table>";
}

require(CPO_BASEDIR.'_include/footer.php');
?>
